## 9.0.4

 - **REFACTOR**: fix all `unnecessary_import` analyzer issues introduced with Flutter 2.8. ([7f0e82c9](https://github.com/FirebaseExtended/flutterfire/commit/7f0e82c978a3f5a707dd95c7e9136a3e106ff75e))
 - **FIX**: remove trailing `/` from `databaseUrl` if present. (#7601). ([abe4c2c7](https://github.com/FirebaseExtended/flutterfire/commit/abe4c2c7e3c9828ffc508d3be5da576e79eb3e73))

## 9.0.3

 - **FIX**: downgrade the Android min SDK to 19 (#7533). ([c657adec](https://github.com/FirebaseExtended/flutterfire/commit/c657adeca078a83ad7157eba91179f3e3ddb5001))

## 9.0.2

 - **FIX**: web reference `path` should now correctly return a path string. ([f9995ce0](https://github.com/FirebaseExtended/flutterfire/commit/f9995ce043d8d60d1e74077064f0df2226291738))
 - **FIX**: database path should default to `/` if no path specified rather than an empty string (fixes #7515). ([c33c3c93](https://github.com/FirebaseExtended/flutterfire/commit/c33c3c931d7e4c654dd0b2cd23d800b43192d95d))

## 9.0.1

 - **FIX**: issue where setting a `databaseURL` can sometimes be ignored (fixes #7502) (#7510).
 - **FIX**: add missing `path` getter for Query (fixes #7495).
 - **DOCS**: fix changelog formatting.
 - **DOCS**: update documentation of `setPersistenceEnabled` to reflect updated return type (fixes #7496) (#7501).

## 9.0.0

> Note: This release has breaking changes.

Realtime Database has been fully reworked to bring the plugin inline with the federated plugin
setup, a more familiar API, better documentation and many more unit and end-to-end tests.

- General

  - Fixed an issue where providing a `Map` with `int` keys would crash.

- `FirebaseDatabase`

  - **DEPRECATED**: `FirebaseDatabase()` has now been deprecated in favor of `FirebaseDatabase.instanceFor()`.
  - **DEPRECATED**: `reference()` has now been deprecated in favor of `ref()`.
  - **NEW**: Added support for `ref()`, which allows you to provide an optional path to any database node rather than calling `child()`.
  - **NEW**: Add emulator support via `useDatabaseEmulator()`.
  - **NEW**: Add support for `refFromURL()`.
  - **BREAKING**: `setPersistenceEnabled()` is now synchronous.
  - **BREAKING**: `setPersistenceCacheSizeBytes()` is now synchronous.
  - **BREAKING**: `setLoggingEnabled()` is now synchronous.

- `DatabaseReference`

  - **BREAKING**: `parent` is now a getter (inline with the JavaScript API).
  - **BREAKING**: `root` is now a getter (inline with the JavaScript API).
  - **BREAKING**: `set()` now accepts an `Object?` value (rather than `dynamic`) and no longer accepts a priority.
  - **NEW**: Added support for `setWithPriority()`.
  - **NEW**: Added support for locally applying transaction results via the `applyLocally` property on `runTransaction`.

- `Query`

  - **NEW**: `once()` now accepts an optional `DatabaseEventType` (rather than just subscribing to the value).
  - **BREAKING**: `limitToFirst()` now asserts the value is positive.
  - **BREAKING**: `limitToLast()` now asserts the value is positive.

- `OnDisconnect`

  - **BREAKING**: `set()` now accepts an `Object?` value (rather than `dynamic`) and no longer accepts a priority.
  - **NEW**: Added support for `setWithPriority()`.

- `Event`

  - **BREAKING**: The `Event` class returned from database queries has been renamed to `DatabaseEvent`.

- **NEW**: `DatabaseEvent` (old `Event`)

  - The `DatabaseEventType` is now returned on the event.
  - The `previousChildKey` is now returned on the event (previously called `previousSiblingKey`).

- **NEW**: `DatabaseEventType`

  - A `DatabaseEventType` is now returned from a `DatabaseEvent`.

- `DataSnapshot`

  - **NEW**: Added support for accessing the priority via the `.priority` getter.
  - **NEW**: Added support for determining whether the snapshot has a child via `hasChild()`.
  - **NEW**: Added support for accessing a snapshot child node via `child()`.
  - **NEW**: Added support for iterating the child nodes of the snapshot via the `.children` getter.
    - **BREAKING** `snapshot.value` are no longer pre-sorted when using order queries, use `.children`
      if you need to iterate over your value keys in order.

- `TransactionResult`

  - **BREAKING**: The result of a transaction no longer returns a `DatabaseError`, instead handle errors of a transaction via a `Future` completion error.

- **NEW**: `Transaction`

  - **NEW**: Added `Transaction.success(value)` return this from inside your `TransactionHandler` to indicate a successful execution.
  - **NEW**: Added `Transaction.abort()` return this from inside your `TransactionHandler` to indicate that the transaction should be aborted.

- `TransactionHandler`

  - **BREAKING** Transaction handlers must now always return an instance of `Transaction` either via `Transaction.success()` or `Transaction.abort()`.

- `DatabaseError`
  - **BREAKING**: The `DatabaseError` class has been removed. Errors are now returned as a `FirebaseException` inline with the other plugins.

## 8.2.0

- **FEAT**: automatically inject Firebase JS SDKs (#7359).

## 8.1.0

- **FEAT**: support initializing default `FirebaseApp` instances from Dart (#6549).

## 8.0.2

- Update a dependency to the latest release.

## 8.0.1

- **REFACTOR**: remove deprecated Flutter Android v1 Embedding usages, including in example app (#7158).
- **FIX**: issue where using `List` values would error on transaction result (#7001).
- **DOCS**: update README with latest Firebase RTDB YouTube tutorial (#7149).
- **CHORE**: update Gradle versions used in Android example app (#7054).

## 8.0.0

> Note: This release has breaking changes.

- **FIX**: List of values erroring on transaction result (#7001).
- **CHORE**: update gradle version across packages (#7054).
- **BREAKING** **FEAT**: add initial support for Web.

## 7.2.2

- **REFACTOR**: firebase_database_platform_interface (#6668).
- **CHORE**: release firebase_database_platform_interface.
- **CHORE**: fix analyze issues (#6977).

## 7.2.1

- Update a dependency to the latest release.

## 7.2.0

- **STYLE**: enable additional lint rules (#6832).
- **FIX**: DataSnapshot is always present (#6754).
- **FEAT**: allow diagnostic logging for android/ios (#6763).
- **FEAT**: DataSnapshot.exists property.

## 7.1.2

- **DOCS**: update database example with increment() (#6518).
- **CHORE**: update v2 embedding support (#6506).
- **CHORE**: rm deprecated jcenter repository (#6431).

## 7.1.1

- Update a dependency to the latest release.

## 7.1.0

- **FEAT**: Add support for RTDB get method. (#6208).

## 7.0.0

- Graduate package to a stable release. See pre-releases prior to this version for changelog entries.

## 7.0.0-dev.3

- **FIX**: podspec osx version checking script should use a version range instead of a single fixed version.

## 7.0.0-dev.2

- **REFACTOR**: move `packages/firebase_database` to `packages/firebase_database/firebase_database` (#5887).

## 7.0.0-dev.1

- **FIX**: return ordered data (#5765).

## 7.0.0-dev.0

> Note: This release has breaking changes.

- **BREAKING** **REFACTOR**: Migrate to sound null-safety (#5441).

## 6.1.2

- **DOCS**: add example for connecting to the default database (#1306).
- **CHORE**: add repository urls to pubspecs (#5542).

## 6.1.1

- **DOCS**: remove incorrect ARCHS in ios examples (#5450).
- **CHORE**: bump min Dart SDK constraint to 2.12.0 (#5430).
- **CHORE**: publish packages (#5429).
- **CHORE**: merge all analysis_options.yaml into one (#5329).
- **CHORE**: publish packages.
- **CHORE**: enable lints for firebase_database (#5233).
- **CHORE**: rm dev dependencies breaking CI (#5221).

## 6.1.0

- This version is not null-safe but has been created to allow compatibility with other null-safe FlutterFire packages such as `firebase_core`.

## 6.0.0

> Note: This release has breaking changes.

- **FEAT**: add check on podspec to assist upgrading users deployment target.
- **BUILD**: commit Podfiles with 10.12 deployment target.
- **BUILD**: remove default sdk version, version should always come from firebase_core, or be user defined.
- **BUILD**: set macOS deployment target to 10.12 (from 10.11).
- **BREAKING** **BUILD**: set osx min supported platform version to 10.12.

## 5.0.0

- Update a dependency to the latest release.
- **BREAKING** **FEAT**: forward port to firebase-ios-sdk v7.3.0.
  - Due to this SDK upgrade, iOS 10 is now the minimum supported version by FlutterFire. Please update your build target version.

## 4.4.0

- **FEAT**: bump android `com.android.tools.build` & `'com.google.gms:google-services` versions (#4269).
- **CHORE**: publish packages.
- **CHORE**: bump gradle wrapper to 5.6.4 (#4158).

## 4.3.0

- **FEAT**: bump compileSdkVersion to 29 (#3975).
- **FEAT**: bump `compileSdkVersion` to 29 in preparation for upcoming Play Store requirement.
- **CHORE**: publish packages.
- **CHORE**: publish packages.

## 4.2.0

- **FEAT**: bump compileSdkVersion to 29 (#3975).
- **FEAT**: update Firebase iOS SDK version to 6.33.0 (from 6.26.0).

## 4.1.1

- Update a dependency to the latest release.

## 4.1.0

- **FIX**: local dependencies in example apps (#3319).
- **FEAT**: implement support for `ServerValue.increment(delta)` (#3109).
- **CHORE**: intellij cleanup (#3326).

## 4.0.0

- Add MacOS support.
- Add MacOS example.
- Firebase iOS SDK versions are now locked to use the same version defined in
  `firebase_core`.
- Firebase Android SDK versions are now using the Firebase Bill of Materials (BoM)
  to specify individual SDK versions. BoM version is also sourced from
  `firebase_core`.
- Allow iOS & MacOS plugins to be imported as modules.

## 3.1.6

- Update lower bound of dart dependency to 2.0.0.

## 3.1.5

- Fix (#81) Android setPersistenceCacheSizeBytes crash when Long value was provided.

## 3.1.4

- Fix for missing UserAgent.h compilation failures.

## 3.1.3

- Replace deprecated `getFlutterEngine` call on Android.

## 3.1.2

- Make the pedantic dev_dependency explicit.

## 3.1.1

- Remove the deprecated `author:` field from pubspec.yaml
- Migrate the plugin to the pubspec platforms manifest.
- Bump the minimum Flutter version to 1.10.0.

## 3.1.0

- Support Android V2 embedding.
- Migrate to using the new e2e test binding.

## 3.0.9

- Updated README instructions for contributing for consistency with other Flutterfire plugins.

## 3.0.8

- Remove AndroidX warning.

## 3.0.7

- Fix possible NullPointerException when plugin is registered without a valid Activity.

## 3.0.6

- Update documentation to reflect new repository location.
- Update unit tests to call `TestWidgetsFlutterBinding.ensureInitialized`.
- Remove executable bit on LICENSE file.

## 3.0.5

- Update google-services Android gradle plugin to 4.3.0 in documentation and examples.

## 3.0.4

- Updated transactions implementation on Android for compatibility with
  newer versions of Flutter engine that require channel calls be made
  on the UI thread.

## 3.0.3

- Automatically use version from pubspec.yaml when reporting usage to Firebase.

## 3.0.2

- Add missing template type parameter to `invokeMethod` calls.
- Bump minimum Flutter version to 1.5.0.

## 3.0.1

- Suppress deprecation warning for BinaryMessages. See: https://github.com/flutter/flutter/issues/33446

## 3.0.0

- Update Android dependencies to latest.

## 2.0.3

- Provide a `toString` implementation for `DatabaseError`.

## 2.0.2+1

- Added an integration test for transactions.

## 2.0.2

- Fix the issue that `getDictionaryFromError` always returns non nil result even when the parameter is nil.

## 2.0.1+3

- Fixing DatabaseReference.set unhandled exception which happened when a successful operation was performed.

## 2.0.1+2

- Log messages about automatic configuration of the default app are now less confusing.

## 2.0.1+1

- Remove categories.

## 2.0.1

- Log a more detailed warning at build time about the previous AndroidX
  migration.

## 2.0.0

- **Breaking change**. Migrate from the deprecated original Android Support
  Library to AndroidX. This shouldn't result in any functional changes, but it
  requires any Android apps using this plugin to [also
  migrate](https://developer.android.com/jetpack/androidx/migrate) if they're
  using the original support library.

  This was originally incorrectly pushed in the `1.1.0` update.

## 1.1.0+1

- **Revert the breaking 1.1.0 update**. 1.1.0 was known to be breaking and
  should have incremented the major version number instead of the minor. This
  revert is in and of itself breaking for anyone that has already migrated
  however. Anyone who has already migrated their app to AndroidX should
  immediately update to `2.0.0` instead. That's the correctly versioned new push
  of `1.1.0`.

## 1.1.0

- **BAD**. This was a breaking change that was incorrectly published on a minor
  version upgrade, should never have happened. Reverted by 1.1.0+1.

  "**Breaking change**. Migrate from the deprecated original Android Support
  Library to AndroidX. This shouldn't result in any functional changes, but it
  requires any Android apps using this plugin to [also
  migrate](https://developer.android.com/jetpack/androidx/migrate) if they're
  using the original support library."

## 1.0.5

- Bumped Android dependencies to latest.

## 1.0.4

- Bumped test and mockito versions to pick up Dart 2 support.

## 1.0.3

- Bump Android and Firebase dependency versions.

## 1.0.2

- Add `onDisconnect` support.

## 1.0.1

- Updated Gradle tooling to match Android Studio 3.1.2.

## 1.0.0

- Bump to released version

## 0.4.6

- Allow null value for `startAt`, `endAt` and `equalTo` queries on Android.

## 0.4.5

- Updated Google Play Services dependencies to version 15.0.0.

## 0.4.4

- Updated firebase_core dependency to ^0.2.2

## 0.4.3

- Simplified podspec for Cocoapods 1.5.0, avoiding link issues in app archives.

## 0.4.2

- Updated `firebase_core` dependency.
- Removed `meta` dependency.

## 0.4.1

- Fixes Dart 2 runtime cast error.

## 0.4.0

- **Breaking change**. Set SDK constraints to match the Flutter beta release.

## 0.3.6

- Fixed Dart 2 type errors.

## 0.3.5

- Enabled use in Swift projects.

## 0.3.4

- Allow null values for Query startAt, endAt, and equalTo

## 0.3.3

- Support to specify a database by URL if required

## 0.3.2

- Fix warnings from the Dart 2.0 analyzer.
- Simplified and upgraded Android project template to Android SDK 27.
- Updated package description.

## 0.3.1

- Fix function name collision when using Firebase Database and Cloud Firestore together on iOS.

## 0.3.0

- **Breaking change**. Upgraded to Gradle 4.1 and Android Studio Gradle plugin
  3.0.1. Older Flutter projects need to upgrade their Gradle setup as well in
  order to use this version of the plugin. Instructions can be found
  [here](https://github.com/flutter/flutter/wiki/Updating-Flutter-projects-to-Gradle-4.1-and-Android-Studio-Gradle-plugin-3.0.1).

## 0.2.0

- Support for multiple databases, new dependency on firebase_core
- Relax GMS dependency to 11.+

## 0.1.4

- Add FLT prefix to iOS types
- Avoid error when clearing FirebaseSortedList

## 0.1.3

- Fix memory leak in FirebaseAnimatedList
- Change GMS dependency to 11.4.+

## 0.1.2

- Change GMS dependency to 11.+

## 0.1.1

- Add RTDB transaction support.

## 0.1.0+1

- Aligned author name with rest of repo.

## 0.1.0

- **Breaking Change**: Added current list index to the type signature of itemBuilder for FirebaseAnimatedList.

## 0.0.14

- Fix FirebaseSortedList to show data changes.

## 0.0.13

- Fixed lingering value/child listeners.

## 0.0.12

- Updated to Firebase SDK to always use latest patch version for 11.0.x builds

## 0.0.11

- Fixes startAt/endAt on iOS when used without a key

## 0.0.10

- Added workaround for inconsistent numeric types when using keepSynced on iOS
- Bug fixes to Query handling

## 0.0.9

- Updated to Firebase SDK Version 11.0.1

## 0.0.8

- Added missing offline persistence and query functionality on Android
- Fixed startAt query behavior on iOS
- Persistence methods no longer throw errors on failure, return false instead
- Updates to docs and tests

## 0.0.7

- Fixed offline persistence on iOS

## 0.0.6

- Various APIs added to FirebaseDatabase and Query
- Added removal and priority to DatabaseReference
- Improved documentation
- Added unit tests

## 0.0.5

- Fixed analyzer warnings

## 0.0.4

- Removed stub code and replaced it with support for more event types, paths, auth
- Improved example

## 0.0.3

- Updated README.md
- Bumped buildToolsVersion to 25.0.3
- Added example app

## 0.0.2

- Fix compilation error

## 0.0.1

- Initial Release
